CakePHP Search Plugin
=====================

[![Software License](https://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat-square)](LICENSE.txt) 
[![Build Status](https://img.shields.io/travis/burzum/cakephp-search-plugin/master.svg?style=flat-square)](https://travis-ci.org/burzum/cakephp-search-plugin) 
[![Build Status](https://img.shields.io/coveralls/burzum/cakephp-search-plugin/master.svg?style=flat-square)](https://coveralls.io/r/burzum/cakephp-search-plugin)

The Search plugin implements the PRG pattern. Post/Redirect/Get (PRG) is a web development design pattern that prevents some duplicate form submissions, creating a more intuitive interface for user agents (users). PRG supports bookmarks and the refresh button in a predictable way that does not create duplicate form submissions.

The plugin allows you to apply filters on the search as well, for example searching between two dates.

---

This is **NOT** a search index or search engine! If you look for something like that checkout Elastic Search or Sphinx.

Requirements
------------

 * CakePHP 3

Documentation
-------------

For documentation, as well as tutorials, see the [docs](docs/) directory of this repository.

Support
-------

For bugs and feature requests, please use the [issues](https://github.com/burzum/cakephp-search-plugin/issues) section of this repository.

Contributing
------------

To contribute to this plugin please follow a few basic rules.

 * Pull requests must be send to the ```develop``` branch. Except hotfixes.
 * Contributions must follow the [PSR2 coding standard recommendation](https://github.com/php-fig).
 * [Unit tests](http://book.cakephp.org/3.0/en/development/testing.html) are required.

License
-------

* Copyright [Friends of Cake](https://github.com/friendsofcake)
* Copyright 2012 - 2015, Florian Krämer

Licensed under The MIT License Redistributions of files must retain the above copyright notice.
